;;;                                                                     ;;;
;;;                     Carnegie Mellon University                      ;;;
;;;                  and Alan W Black and Kevin Lenzo                   ;;;
;;;                      Copyright (c) 1998-2000                        ;;;
;;;                        All Rights Reserved.                         ;;;
;;;                                                                     ;;;
;;; Permission is hereby granted, free of charge, to use and distribute ;;;
;;; this software and its documentation without restriction, including  ;;;
;;; without limitation the rights to use, copy, modify, merge, publish, ;;;
;;; distribute, sublicense, and/or sell copies of this work, and to     ;;;
;;; permit persons to whom this work is furnished to do so, subject to  ;;;
;;; the following conditions:                                           ;;;
;;;  1. The code must retain the above copyright notice, this list of   ;;;
;;;     conditions and the following disclaimer.                        ;;;
;;;  2. Any modifications must be clearly marked as such.               ;;;
;;;  3. Original authors' names are not deleted.                        ;;;
;;;  4. The authors' names are not used to endorse or promote products  ;;;
;;;     derived from this software without specific prior written       ;;;
;;;     permission.                                                     ;;;
;;;                                                                     ;;;
;;; CARNEGIE MELLON UNIVERSITY AND THE CONTRIBUTORS TO THIS WORK        ;;;
;;; DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING     ;;;
;;; ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT  ;;;
;;; SHALL CARNEGIE MELLON UNIVERSITY NOR THE CONTRIBUTORS BE LIABLE     ;;;
;;; FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES   ;;;
;;; WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN  ;;;
;;; AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,         ;;;
;;; ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF      ;;;
;;; THIS SOFTWARE.                                                      ;;;
;;;                                                                     ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Lexicon, LTS and Postlexical rules for eki_et
;;;

;;; Load any necessary files here

(define (eki_et_addenda)
  "(eki_et_addenda)
Basic lexicon should (must ?) have basic letters, symbols and punctuation."

(lex.add.entry '("a" nn (((pau a a) 1))))
(lex.add.entry '("b" nn (((pau b e e) 1))))
(lex.add.entry '("c" nn (((pau t s e e) 1))))
(lex.add.entry '("d" nn (((pau t e e) 1))))
(lex.add.entry '("e" nn (((pau e e) 1))))
(lex.add.entry '("f" nn (((pau e f f) 1))))
(lex.add.entry '("g" nn (((pau k e e) 1))))
(lex.add.entry '("h" nn (((pau h a a) 1))))
(lex.add.entry '("i" nn (((pau i i) 1))))
(lex.add.entry '("j" nn (((pau j o ty) 1))))
(lex.add.entry '("k" nn (((pau k a a) 1))))
(lex.add.entry '("l" nn (((pau e l l) 1))))
(lex.add.entry '("m" nn (((pau e m m) 1))))
(lex.add.entry '("n" nn (((pau e n n) 1))))
(lex.add.entry '("o" nn (((pau o o) 1))))
(lex.add.entry '("p" nn (((pau p e e) 1))))
(lex.add.entry '("q" nn (((pau k u u) 1))))
(lex.add.entry '("r" nn (((pau e r r) 1))))
(lex.add.entry '("s" nn (((pau e s s) 1))))
(lex.add.entry '("t" nn (((pau t e e) 1))))
(lex.add.entry '("u" nn (((pau u u) 1))))
(lex.add.entry '("v" nn (((pau v e e) 1))))
(lex.add.entry '("w" nn (((pau k a k) 1)((s i s) 0)((v e e) 1))))
(lex.add.entry '("" nn (((pau q q) 1))))
(lex.add.entry '("" nn (((pau x x) 1))))
(lex.add.entry '("" nn (((pau c c) 1))))
(lex.add.entry '("" nn (((pau y y) 1))))

(lex.add.entry '("x" nn (((pau i k s) 1)))) 
(lex.add.entry '("y" nn (((pau i g r e k) 1)))) 
(lex.add.entry '("z" nn (((pau t s e t t) 1))))  

(lex.add.entry '("" nn (((pau sh a a) 1)))) 
(lex.add.entry '("" nn (((pau sh e e) 1)))) 


(lex.add.entry '("*" n (((pau t x r n) 1))))
(lex.add.entry '("%" n (((pau p r o t) 1) ((s e n t) 0) (( t i) 0))))
(lex.add.entry '("$" n (((pau t o l) 0) ((l a) 0) ((r i t t) 1))))
(lex.add.entry '("" n (((pau n a e) 1) ((l a) 0) )))
(lex.add.entry '("" n (((pau e u) 1) ((r o t t) 0) )))
(lex.add.entry '("" n (((pau s e n) 1) ((t i) 0) )))
(lex.add.entry '("@" n (((pau x t t) 1))))
(lex.add.entry '("&" n (((pau x n d ) 1))))
(lex.add.entry '("+" n (((pau p l u s s) 1))))
(lex.add.entry '("#" n (((pau t r e l) 1) ((l i d pau) 0) )))
(lex.add.entry '(">" n (((pau o n n) 1) ((s u u) 0) ((r e m) 0) ((pau) 0)  )))
(lex.add.entry '("<" n (((pau o n n) 1) ((v x i k) 0) ((s e m) 0)((pau) 0))))
(lex.add.entry '("=" n (((pau v q r) 1) ((d u b) 0) ((pau) 0))))
(lex.add.entry '("" n (((pau p a) 1) ((r a) 0) ((g r a h v) 0)((pau) 0))))
(lex.add.entry '("-" n (((pau k u) 1) ((n i) 0) ((pau) 0))))


(lex.add.entry '("." punc nil))
(lex.add.entry '("'" punc nil))
(lex.add.entry '(":" punc nil))
(lex.add.entry '(";" punc nil))
(lex.add.entry '("," punc nil))
(lex.add.entry '("" punc nil))
(lex.add.entry '("" punc nil))
(lex.add.entry '("" punc nil))
(lex.add.entry '("\"" punc nil))
(lex.add.entry '("\\" punc nil))
(lex.add.entry '("`" punc nil))
(lex.add.entry '("?" punc nil))
(lex.add.entry '("!" punc nil))
(lex.add.entry '("" punc nil))
(lex.add.entry '("" punc nil))
(lex.add.entry '("" punc nil))
(lex.add.entry '("_" punc nil))
(lex.add.entry '("" punc nil))
(lex.add.entry '("" punc nil))
(lex.add.entry '("" punc nil))
(lex.add.entry '("|" punc nil))

(lex.add.entry '("(" prepunctuation (((pau s u l) 1)((g u ) 0)((d e s pau) 0) )))
(lex.add.entry '(")" n (((pau pau) 1))))
(lex.add.entry '("[" prepunctuation (((pau s u l) 1)((g u ) 0)((d e s pau) 0) )))
(lex.add.entry '("]" n (((pau pau) 1))))
(lex.add.entry '("{" prepunctuation (((pau s u l) 1)((g u ) 0)((d e s pau) 0) )))
(lex.add.entry '("}" n (((pau pau) 1))))



)


(define (eki_et_lts_function word features)
  "(eki_et_lts_function WORD FEATURES)
Return pronunciation of word not in lexicon."
(if (eq? festvox_debug 1)	 (print (format nil "[word sisse: %s]" word)))
;(print word)
;;; Asendame snas tundmatud mrgid - snaga ;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  (let ((dword word) (phones) (syls))
;;;;;; Kui on rkimine ;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;(print word)
;  (set! word (et_downcase word))   
;	(print word)
  (set! phones ( lts.apply word 'eki_et ))
;	(print phones)

  (set! syls (eki_et_lex_syllabify_phstress phones))


  ;(set! syls (palat syls))

	(if (eq? festvox_debug 1)	 (print (format nil "  [word valja: %l]" syls)))
    (list word features syls)    
    ))
    



(define (et_downcase word)
  "(et_downcase WORD)
Downs case word by letter to sound rules becuase or accented form
this can't use the builtin downcase function."
  (lts.apply word 'eki_et_downcase))



(define (eki_et_is_vowel x)
  (string-equal "+" (phone_feature x "vc")))

(define (eki_et_is_consonant x)
  (string-equal "-" (phone_feature x "vc")))

(define (eki_et_is_sonorant x)
  (string-equal "+" (phone_feature x "csonorant")))

(define (eki_et_is_klusiil x)
  (string-equal "+" (phone_feature x "klusiil")))

(define (eki_et_contains_vowel l)
  (member_string
   t
   (mapcar (lambda (x) (eki_et_is_vowel x)) l)))

(define (eki_et_lex_sylbreak currentsyl remainder)
  "(eki_et_lex_sylbreak currentsyl remainder)
t if this is a syl break, nil otherwise. Ttab, puudub endiselt ka-dri"
(set! last_c (car currentsyl))
(set! last_cc (car(cdr currentsyl)))

  (cond
   ((and
	(eki_et_is_vowel (car currentsyl))
	(eki_et_is_vowel (car remainder))
	(not (eki_et_is_vowel (car (cdr currentsyl))))
	)    
	nil)
   ((and
	(not (eki_et_is_vowel (car(cdr remainder))))
	(not (eki_et_is_vowel (car remainder)))
	)    
	nil)

   ((not (eki_et_contains_vowel currentsyl))
    nil)

    (t
     ;    	
     t)))


(define (is_single_syl_word_no_stress syl)
"Kunagi kirjutan siia midagi"
(let ((yhend_list '("ma" "mu" "sa" "su" "ta" "nat" "ja" "ju" "no" "va")) (syl_string "") (result 0))	
(while syl 
	(set! syl_string (string-append syl_string (car syl)))
(set! syl (cdr syl)))
		(while yhend_list
			(if (string-matches syl_string (car yhend_list)) 	(set! result 1))
		(set! yhend_list (cdr yhend_list)))
  (set! result result)))


(define (is_foreign_stress syl)
"Kunagi kirjutan siia midagi"
(let ((yhend_list '(":" "aa" "ee" "ii" "oo" "uu" "" "" "" "" "au" "ae" "ao" "oi" "ou" "oe" "oa" "i" "u" "e" "a" "o" "i" "u" "e" "o" "eu" "ea" "eo" "iu" "i" "e" "a" "i")) (syl_string "") (result 0))
	
(while syl ;; kehv koht aga listi ta stringiga mtida lihtsalt ei lase
	(set! syl_string (string-append syl_string (car syl)))
	(set! syl (cdr syl)))

		(while yhend_list
			(if (string-matches syl_string (string-append ".*" (string-append (car yhend_list) ".*"))) 
				(set! result 1))
		(set! yhend_list (cdr yhend_list)))
  (set! result result)))


(define (estonian_stress mysyls syl_count)
"M. Mihkla nim. silpide rhu mramise definitsioon"
(let ((result nil) (curr_syl nil) (curr_syl_numb 0) (foreign_stress 0))
(set! foreign_stress (is_foreign_stress (car (cdr mysyls))))
	(while mysyls
		(set! curr_syl_numb (+ curr_syl_numb 1))
		(set! curr_syl (car mysyls))
      (cond 
       ((and (eqv? syl_count 1)(> (is_single_syl_word_no_stress curr_syl) 0)) (set! stress 1))
       ((eqv? curr_syl_numb 1) (if (> foreign_stress 0) (set! stress 1) (set! stress 1)))	
       ((eqv? curr_syl_numb 2) (if (> foreign_stress 0) (set! stress 1) (set! stress 0)))	
       ((and (> (% curr_syl_numb 2) 0)(> syl_count curr_syl_numb)) (set! stress 1))
       (t (set! stress 0)))
		 (set! mysyls (cdr mysyls))
     (set! result (cons (list curr_syl stress) result)))
(set! mysyls result)))



(define (eki_et_lex_syllabify_phstress phones)
;(format stderr "phones %s\n" phones) 
 (let ((syl nil) (syls nil) (p phones) (stress 0) (syl_count 0))
    (while p

     (set! syl nil)
     (set! stress 0)
     (while (and p (not (eki_et_lex_sylbreak syl p)));;and

       (set! syl (cons (car p) syl))
       (set! p (cdr p))

    );while
		(set! syl_count (+ syl_count 1))
    (set! syls (cons (reverse syl) syls))

);while p

		(set! syls (estonian_stress (reverse syls) syl_count))
		;(print (reverse syls))
    (reverse syls)
	     
))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; OR: Hand written letter to sound rules
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


 (lts.ruleset
  eki_et


	(  
	(NUM 0 1 2 3 4 5 6 7 8 9 ) 
	(TH a e i o u q x c y ) 
;	(KH b d f g h j k l m n p r s t v 5 4 )
;	(EISH f b d g h j l m n r s v 5 4 )
;        (SH k p t g b d)
;        (PTH aa ee ii oo uu qq cc yy xx ai ei ui oi qi ci xi au qu xu eu iu ae oe qe xe ea )
;	(LMNR l m n r )
;	(IJ i j )
;	(HH a e i o u q x c y l m n 4 r j v w )

 	)
  (

  ( [ "." ] = p u n k t  )
  ( [ "," ] = k o m a  )
  ( [ 1 ] = y k s  )
  ( [ 2 ] = k a k s  )
  ( [ 3 ] = k o l m  )
  ( [ 4 ] = n e l i )
  ( [ 5 ] = v i i s  )
  ( [ 6 ] = k u u s  )
  ( [ 7 ] = s e i t s e  )
  ( [ 8 ] = k a h e k s a )
  ( [ 9 ] = y h e k s a  )
  ( [ 0 ] = n u l  )  
  ( [ - ]  = s i d e k r i i p s )   


	;kell on piisavalt sage sna -- teeme erandi

  ( [ c ] i  = t s ) 
	( [ c ] e  = t s ) 
  ( [ c ]   = t s ) 
	( [ c ] o e  = t s )  
	( [ c ] a e  = t s ) 
  ( # [ c h ] = t sh ) 
	( [ c ] = k) 

	( [ q u  ] = k v ) 
	( [ q ] = k )
  ( [ z z ] = t s ) 
	( [ z ] = s ) 
  ( [  : ] = sh )
	( [  ] = sh ) 
  ( [  : ] = sh )
	( [  ] = sh ) 



;  ( HH [ f ] HH = fx )

  ( [ n : ] k = ng ) ;vljas
  ( [ n : ] g = ng )	;vljas

  
  ( [ n ] k = ng )
  ( [ n ] g = ng )

	( [ y ] = i ) 
	( [ x ] = k s )

; ( [ t t ] = t: )
; ( [ k k ] = k: )
; ( [ p p ] = p: )


; poolvokaalid 

  ( TH [ u ] TH = u w )
  ( TH [ i ] TH = i j )
 

; pika  teisendus vokaali ees


  ( [   ] TH = y i j )
  ( [   ] j = y i )


; ksikhlikute viimane teisendusvimalus
  

  ( [ a ] = a )
  ( [ e ] = e )
  ( [ i ] = i )  
  ( [ o ] = o )
  ( [ u ] = u )
  ( [  ] = q )
  ( [  ] = x )
  ( [  ] = c )
  ( [  ] = y )


( [ g ] = g ) 
( [ b ] = b ) 
( [ d ] = d )


( [ k ] = k ) 
( [ p ] = p ) 
( [ t ] = t )


  ( [ m ] = m )



  ( [ n ] = n )



  ( [ s ] = s )



  ( [ r ] = r )



  ( [ l ] = l )




  ( [ f : ] = f ) ;vljas
  ( [ f ] = f )





  ( [ h ] = h )
  

  ( [ j ] = j )


  ( [ v ] = v )
  ( [ w ] = v )




  ( [ pau ] = pau )

   ))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Postlexical Rules 
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (eki_et::postlex_rule1 utt)
  "(eki_et::postlex_rule1 utt)
A postlexical rule form correcting phenomena over word boundaries."
; (print (utt.relationnames utt))
;	(print guess_pos)
;	(utt.relation.print utt 'SylStructure)
;	(utt.relation.print utt 'Token)
;	(utt.relation.print utt 'Word) ;Sama mis SylStructure
;	(utt.relation.print utt 'Phrase)
;	(utt.relation.print utt 'Syllable)
;	(utt.relation.print utt 'Intonation)
;  (print (utt.relation_tree utt 'SylStructure))
;  (print (utt.relation_tree utt 'Token))
;  (print (utt.relation_tree utt 'Word))
;  (print (utt.relation_tree utt 'Phrase))
;  (print (utt.relation_tree utt 'Syllable))
;  (print (utt.relation_tree utt 'Intonation))
;  (utt.relation.print utt 'Segment)

;(print (utt.features utt 'Word '(name pos)))
;(print (utt.relation_tree utt 'Word))
;(print (utt.relation_tree utt 'Phrase))
;(print (utt.relation_tree utt 'Intonation))

	(if (eq? festvox_debug 1)	 (print "*** lausungi piir ***" ))
;(utt.save utt "utt.txt")
  (mapcar
   (lambda (s)
	
     )
   (utt.relation.items utt 'Segment))
   utt)

(define (eki_et_pre_hook_function entry)
  "(msu_ru_pre_hook_function entry)
  convert stress and word to syllables"
;(print "pre_hook")
(list entry)
)



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Lexicon definition
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(lex.create "eki_et")
(lex.set.phoneset "eki_et")
(lex.set.lts.method 'eki_et_lts_function)


(if (probe_file (path-append eki_et_tonu_hts::hts_dir "/home/indrek/speech/lexicon/eki_et_lexicon_mod.out"))
    (lex.set.compile.file (path-append eki_et_tonu_hts::hts_dir 
                                       "/home/indrek/speech/lexicon/eki_et_lexicon_mod.out")))
(eki_et_addenda)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Lexicon setup
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (eki_et_tonu::select_lexicon)
  "(eki_et_tonu::select_lexicon)
Set up the lexicon for eki_et."
  (lex.select "eki_et")

  ;; Post lexical rules
	(lex.set.pre_hooks 'eki_et_pre_hook_function)
  (set! postlex_rules_hooks (list eki_et::postlex_rule1))
)

(define (eki_et_tonu::reset_lexicon)
  "(eki_et_tonu::reset_lexicon)
Reset lexicon information."
  t
)

(provide 'eki_et_tonu_lexicon)

